using System.Xml;
using System.Net;
using System.IO;
using System.Collections.Generic;

/// <summary>
/// Trida pouzita pouze pro nacteni Teplomeru z WEBu
/// Pouijte metody getTeplomerNames() a getTeplomerbyName(string teplomerName)
/// </summary>
public class Teplomery
{
    public static XmlDocument getTeplomeryXML()
	{
        try
        {
            XmlDocument doc = new XmlDocument();

            HttpWebRequest webRequest = (HttpWebRequest)WebRequest.Create("http://teplomer.altairis.cz/GetRss.ashx");
            webRequest.Timeout = 6000;
            HttpWebResponse webResponse = (HttpWebResponse)webRequest.GetResponse();
            Stream responseStream = webResponse.GetResponseStream();
            XmlTextReader responseReader = new XmlTextReader(responseStream);

            doc.Load(responseReader);
            responseReader.Close();
            return doc;
        }
        catch
        {
            return new XmlDocument();
        
        }
	}

    public static List<string> getTeplomerNames()
    {
        XmlDocument doc = Teplomery.getTeplomeryXML();
        XmlNodeList XMLitems = doc.GetElementsByTagName("item");
        List<string> SeznamTeplomeru = new List<string>();

        foreach (XmlNode teplomer in XMLitems)
        {
            for (int i = 0; i < teplomer.ChildNodes.Count; i++)
            {
                if (teplomer.ChildNodes[i].Name == "tm:sensorName") SeznamTeplomeru.Add(teplomer.ChildNodes[i].InnerText);
            }
        }
        return SeznamTeplomeru;
    }

    public static Teplomer getTeplomerbyName(string teplomerName)
    {
        XmlDocument doc = Teplomery.getTeplomeryXML();
        XmlNodeList XMLitems = doc.GetElementsByTagName("item");
        Teplomer Vybranyteplomer = new Teplomer(teplomerName, "not set", "0");

        foreach (XmlNode teplomer in XMLitems)
        {
            if (teplomer.ChildNodes[4].InnerText == teplomerName)
            {
                Vybranyteplomer = new Teplomer( teplomerName , teplomer.ChildNodes[5].InnerText , teplomer.ChildNodes[8].InnerText);
            }
        }
        return Vybranyteplomer;
    }
}
